# -*- coding: utf-8 -*-
# this file is released under public domain and you can use without limitations

#########################################################################
## This is a samples controller
## - index is the default action of any application
## - user is required for authentication and authorization
## - download is for downloading files uploaded in the db (does streaming)
## - call exposes all registered services (none by default)
#########################################################################

from datetime import datetime

def index():
    """
    example action using the internationalization operator T and flash
    rendered by views/default/index.html or views/generic.html
    """
    response.title = "HABEX 2 APRS Packet Decoder"
    response.flash = ""
    #response.alerts = [dict(message='first message',showclose=False),dict(message="ohai",type='warn'),dict(message="oooooops",title="there was an error bitch",type='error'),dict(message="the database add succeeded, you can ignore any other errors",title="Success!",type='success'),]
    response.alerts = [dict(message="Are you guys ready to decode some packets!?".title()),]
    
    micedata = None
    
    if not session.sender_callsign:
        session.sender_callsign = 'NOCALL'
    if not session.destination_callsign:
        session.destination_callsign = 'S4PRTR'
    if not session.micepacket:
        session.micepacket = '`.+Gl#PO/"4q}HABEX|!V%@\'b|!w!u!'
    
    miceform = SQLFORM.factory(
        Field('sender_callsign','string',default=session.sender_callsign),
        Field('destination_callsign','string',default=session.destination_callsign,required=True),
        Field('packet','string',default=session.micepacket,required=True),)
    if miceform.process().accepted:
        session.sender_callsign= miceform.vars.sender_callsign
        session.destination_callsign = miceform.vars.destination_callsign
        session.micepacket = miceform.vars.packet
        response.flash = ""
        try:
            micedata = decodeMICE(miceform.vars.packet,miceform.vars.destination_callsign)
            try:
                db.micelogs.insert(
                    timestamp = datetime.today(),
                    raw_sender_callsign = miceform.vars.sender_callsign,
                    raw_destination_callsign = miceform.vars.destination_callsign,
                    raw_packet = miceform.vars.packet,
                    decoded_long = micedata['long'],
                    decoded_lat = micedata['lat'],
                    decoded_alt = micedata['alt'],
                    decoded_ambiguity = micedata['ambiguity'],
                    decoded_messageType = micedata['messageType'],
                    decoded_message = micedata['message'])
            except:
                db.rollback()
            else:
                db.commit()
        except:
            response.alerts += [dict(message='There was something wrong with your packet!',type='error')]
    elif miceform.errors:
        response.flash = ""
        response.alerts += [dict(message='There was an error with the form!',type='error')]
    
    return dict(miceform=miceform,micedata=micedata)

def logs():
    response.title = "HABEX 2 APRS Packet Decoder"
    return dict(micelogs=db(db.micelogs.id > 0).select(db.micelogs.ALL,orderby=db.micelogs.timestamp))

def csv_logs():
    import gluon.contenttype
    response.headers['Content-Type'] = \
        gluon.contenttype.contenttype('.csv')
    query = db.micelogs.id > 0
    if not query:
        return None
    response.headers['Content-disposition'] = 'attachment; filename=%s_%s.csv'\
         % ('habex2','logs')
    return str(db(query,ignore_common_filters=True).select())

def user():
    """
    exposes:
    http://..../[app]/default/user/login
    http://..../[app]/default/user/logout
    http://..../[app]/default/user/register
    http://..../[app]/default/user/profile
    http://..../[app]/default/user/retrieve_password
    http://..../[app]/default/user/change_password
    use @auth.requires_login()
        @auth.requires_membership('group name')
        @auth.requires_permission('read','table name',record_id)
    to decorate functions that need access control
    """
    return dict(form=auth())


def download():
    """
    allows downloading of uploaded files
    http://..../[app]/default/download/[filename]
    """
    return response.download(request,db)


def call():
    """
    exposes services. for example:
    http://..../[app]/default/call/jsonrpc
    decorate with @services.jsonrpc the functions to expose
    supports xml, json, xmlrpc, jsonrpc, amfrpc, rss, csv
    """
    return service()


@auth.requires_signature()
def data():
    """
    http://..../[app]/default/data/tables
    http://..../[app]/default/data/create/[table]
    http://..../[app]/default/data/read/[table]/[id]
    http://..../[app]/default/data/update/[table]/[id]
    http://..../[app]/default/data/delete/[table]/[id]
    http://..../[app]/default/data/select/[table]
    http://..../[app]/default/data/search/[table]
    but URLs must be signed, i.e. linked with
      A('table',_href=URL('data/tables',user_signature=True))
    or with the signed load operator
      LOAD('default','data.load',args='tables',ajax=True,user_signature=True)
    """
    return dict(form=crud())
